/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009-2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_QUERY_P_H
#define AQDB_QUERY_P_H

#include "aqdb_query_be.h"



static AQDB_QUERY_EXPR *AQDB_Query_MkFieldExpr(AQDB_QUERY *q, const char *name);
static int AQDB_Query_GetFieldData(AQDB_QUERY *q, AQDB_QUERY_EXPR *expr);


static int AQDB_Query_Expr__readOperand(AQDB_QUERY *q,
                                        const char **pp,
                                        AQDB_QUERY_EXPR **pExp);
static int AQDB_Query_Expr__readExpression(AQDB_QUERY *q,
                                           const char **pp,
                                           AQDB_QUERY_EXPR **pExp);

static int AQDB_Query_Expr__transformData(AQDB_QUERY_EXPR *expr,
                                          AQDB_DATA_TYPE resultType);


static int AQDB_Query_Expr_CalculateInt(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr_CalculateString(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr_CalculateBin(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr_CalculateValue(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr_CalculateDate(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr_CalculateTimestamp(AQDB_QUERY_EXPR *expr);

static int AQDB_Query_Expr_CalculateField(AQDB_QUERY_EXPR *expr);
static int AQDB_Query_Expr__Calculate(AQDB_QUERY_EXPR *expr);

static void AQDB_Query_Expr_Dump(const AQDB_QUERY_EXPR *expr, FILE *f, int indent);

static const char *AQDB_Query_Expr_StrCaseStr(const char *haystack, const char *needle);

#endif



