/****************************************************************************
 * This file is part of the project AqDatabase.
 * AqDatabase (c) by 2016 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef CHECKOBJECTS_H
#define CHECKOBJECTS_H


#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>

#include "type1.h"
#include "type2.h"

#include <gwenhywfar/idlist64.h>


int check_type1_object(AQDB_DB *db, const TYPE1 *t);
int check_type1_object_swapped(AQDB_DB *db, const TYPE1 *t);
int read_type1_objects(AQDB_DB *db, TYPE1_LIST *tl, AQDB_ID tableId, const char *queryExpr);

int check_type2_object(AQDB_DB *db, const TYPE2 *t);
int read_type2_objects(AQDB_DB *db, TYPE2_LIST *tl, AQDB_ID tableId, const char *queryExpr);

GWEN_IDLIST64 *read_type1_objects_into_idlist(AQDB_DB *db, AQDB_ID tableId, const char *queryExpr);


#endif
